package sun.misc;

import java.io.PrintStream;

class RegexpNode
{
    char c;
    RegexpNode firstchild;
    RegexpNode nextsibling;
    int depth;
    boolean exact;
    Object result;
    String re;
    
    RegexpNode() {
        this.re = null;
        this.c = '#';
        this.depth = 0;
    }
    
    RegexpNode(char c, int depth) {
        this.re = null;
        this.c = c;
        this.depth = depth;
    }
    
    RegexpNode add(char c) {
        RegexpNode regexpNode = this.firstchild;
        RegexpNode firstchild;
        if (regexpNode == null) {
            firstchild = new RegexpNode(c, this.depth + 1);
        }
        else {
            while (regexpNode != null) {
                if (regexpNode.c == c) {
                    return regexpNode;
                }
                regexpNode = regexpNode.nextsibling;
            }
            firstchild = new RegexpNode(c, this.depth + 1);
            firstchild.nextsibling = this.firstchild;
        }
        return this.firstchild = firstchild;
    }
    
    RegexpNode find(char c) {
        RegexpNode regexpNode = this.firstchild;
        while (regexpNode != null) {
            if (regexpNode.c == c) {
                return regexpNode;
            }
            regexpNode = regexpNode.nextsibling;
        }
        return null;
    }
    
    void print(PrintStream printStream) {
        if (this.nextsibling != null) {
            printStream.print("(");
            while (this != null) {
                printStream.write((int)this.c);
                if (this.firstchild != null) {
                    this.firstchild.print(printStream);
                }
                this = this.nextsibling;
                printStream.write((this != null) ? 124 : 41);
            }
        }
        else {
            printStream.write((int)this.c);
            if (this.firstchild != null) {
                this.firstchild.print(printStream);
            }
        }
    }
}
